import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;

public class ColorPanel extends JPanel {

	  //public DrawingPanelFrame drawingFrame;
	   public DrawingPanel panel;
	   public Color background;
	   public int highlightFaces = -1;
	   public Color highlightColor = new Color(240, 242, 0);
	   public JScrollPane scrollPane;
	   
	   /**
	   setTitle( "Scrolling Pane Application" );
		setSize( 300, 200 );
		setBackground( Color.gray );

		JPanel topPanel = new JPanel();
		topPanel.setLayout( new BorderLayout() );
		getContentPane().add( topPanel );

		Icon image = new ImageIcon( "main.gif" );
		JLabel label = new JLabel( image );

		// Create a tabbed pane
		scrollPane = new JScrollPane();
		scrollPane.getViewport().add( label );
		topPanel.add( scrollPane, BorderLayout.CENTER ); **/
		
		
	   public ColorPanel(DrawingPanelFrame frame) {
		  //this.drawingFrame = drawingFrame;
		  this.panel = frame.dP;
		  this.setOpaque(true);
		  background = new Color(190,190, 190);
	      setBackground( background );
	      /**
	      scrollPane = new JScrollPane();
	      this.setLayout( new BorderLayout() );
	      this.add( scrollPane, BorderLayout.CENTER);
	      JScrollPane scrollableTextArea = new JScrollPane(textArea);
	      scrollableTextArea.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	      scrollableTextArea.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	      **/
	   }

	   protected void paintComponent(Graphics graphics){
		   super.paintComponent(graphics);
	    	Graphics2D g = (Graphics2D) graphics;
	    	
	    	ArrayList<Face> faces = null;
	    	
	    	if ( panel!=null && panel.Curve.faces != null) {
	    		faces = panel.Curve.faces;
	    		
	    		for (int l=0; l< faces.size(); l++)  {
	    			Face f = faces.get(l);
	    		//	f.setWindingNum( (int) windingNum( allPoints, f.getRep() ) ); 
	    			if ( f!= null) {
	    				Color c = f.getColor();
	    				
	    				if ( f.getType() == highlightFaces ) {
	    					c = highlightColor;
	    				}
	    				if ( panel.selectedFace != null && panel.selectedFace.equals(f) ) {
	    					c = new Color(0, 0, 0);
	    				}
	    				
	    				graphics.setColor(c);
	    				
	    	    		g.setColor(Color.BLACK);
	    				
	    				String type;
	    				if ( f.getType() == 1) { type = "monogon"; }
	    				else if ( f.getType() ==2 ) { type = "bigon"; }
	    				else if ( f.getType() == 3) { type = "triangle"; }
	    				else {
	    					type = "none";
	    				}
	    				String w; 
	    				if ( f.getWindingNum() > 0 ) { w = "  "  + f.getWindingNum(); }
	    				else if ( f.getWindingNum() == 0  )  { w = "  " + f.getWindingNum(); }
	    				else { w = "" +f.getWindingNum(); } 
	    				g.setColor(Color.BLACK);
	    	    		graphics.drawString("Face " + l + ":    ", 30, 50+20*l);
	    	    		graphics.drawString("  wNum = " + w + ", " + type, 80, 50+20*l);
	    	    		g.setColor(c);
	    	    		graphics.fillRect(10, 40+20*l, 10, 10);
	    	    		graphics.setColor(c);
	    	    		
	    			}
	    			
	    		} 
	    	}
	    	/**
	    	if ( panel.bestArea != Integer.MAX_VALUE ) {
				g.setColor(Color.red);
				double a = panel.bestArea * 10000;
				a = Math.round(a);
				a = a / 10000;
				panel.bestArea = a;
				g.setColor(Color.BLACK);
				g.fillRect(5, 345, 300, 20);
				g.setColor(Color.RED);
				graphics.drawString("Best homotopy area so far: " + panel.bestArea, 20, 360);
				g.setColor(Color.BLACK);
				graphics.drawString("Titus sequence of the homotopy: ", 20, 380);
				g.setColor(Color.blue);
				for (int i=0; i < panel.bestTitus.size(); i++) {
					String S = panel.bestTitus.get(i);
					graphics.drawString(S, 60, 400+20*i);
				}
			} **/
	    	
	   }
}

