
import java.util.ArrayList;

import java.util.*;


public class Counter {
	
	public Counter() {
	}
		
	/**
	public static void main(String[] args) {
		Counter C = new Counter();
		ArrayList<String> intSequences = new ArrayList<String>();
		
		int totalSplits = 0;
		
		int k = 3;
		intSequences = C.allIntSequences(k );
		intSequences.remove(0);
		int i = 1;
		
		//int[] Seq = {0,1,2,0,3,4,4,5,6,3,5,6,7,8,8,9,9,2,1,7};
		//intSequences.add("abcdefgchaigjekkdjfibh");
		
		int secondBest = 0;
		
		
		for ( String intSeq: intSequences)  {
			
			int curSplits = C.TNS( intSeq);
			if ( curSplits > secondBest) {
				secondBest = curSplits;
			}
			totalSplits += curSplits;
			System.out.println( i + ". " + "Total splits of " + intSeq + " is " + curSplits );
			if (  curSplits >= 50) {
				//System.out.println("Total splits of " + intSeq + " is " + curSplits );
			}
			i++;
		}
		System.out.println("The second worst case was: " + secondBest + " splits");
		System.out.println("There were " + intSequences.size() + " combinatorially distinct intersection sequences of length " + k);
		System.out.println("Average splits = "  + totalSplits/intSequences.size() );
	} 
	 **/
	
	// the average complexity (# int points) of a curve after a split (averages across direct + wraparounds)
	public double avgSplits(ArrayList<Integer> intersectionSeq) {
		String intSeq = convert(intersectionSeq); // convert the intseq to a string 
		ArrayList<Character> intPoints = new ArrayList<Character>();
    	for (int i=0; i< intSeq.length() ; i++) {
    		char cur = intSeq.charAt(i);
    		if ( !intPoints.contains(new Character(cur)) && doesSplit(intSeq, cur) ) {
    			intPoints.add( new Character(cur) ); // find all int points
    		}
    	}
    	if ( intPoints.size() == 0) {  // base case: curve is simple! 
    		return 0;
    	}
    	int[] splitSizes = new int[intPoints.size()*2]; // save the split sizes for debugging
    	double totalSplits = 0;
    	for (int i=0; i<intPoints.size(); i++) {
    		Character c = intPoints.get(i);
    		int split1 = numSplits(splitSeq(intSeq, c, true) ); // wraparound split
    		int split2 = numSplits( splitSeq(intSeq, c, false) ); // direct split
    		splitSizes[2*i] = split1;
    		splitSizes[2*i+1] = split2;
    		totalSplits += split1+split2;
    	}
    	return totalSplits/ (intPoints.size() *2 ); // return the average 
	}
	
	public double avgMaxSplits( ArrayList<Integer> intersectionSeq) {
		String intSeq = convert(intersectionSeq); // convert the intseq to a string 
		ArrayList<Character> intPoints = new ArrayList<Character>();
    	for (int i=0; i< intSeq.length() ; i++) {
    		char cur = intSeq.charAt(i);
    		if ( !intPoints.contains(new Character(cur)) && doesSplit(intSeq, cur) ) {
    			intPoints.add( new Character(cur) );
    		}
    	}
    	if ( intPoints.size() == 0) {  // base case: curve is simple! 
    		return 1;
    	}
    	int[] splits = new int[intPoints.size()]; // save the splits for debugging
    	double totalSplits = 0;
    	for (int i=0; i<intPoints.size(); i++) {
    		Character c = intPoints.get(i);
    		// take the max # of splitting points (int points) on the direct/wraparound split
    		int nextSplit = Math.max( numSplits(splitSeq(intSeq, c, true)), numSplits( splitSeq(intSeq, c, false) ) ) ;
    		splits[i] = nextSplit;
    		totalSplits += nextSplit;
    	}
    	return totalSplits/intPoints.size(); // return the average 
	}
	
	public int numSplits( String intSeq) {
		ArrayList<Character> intPoints = new ArrayList<Character>();
    	for (int i=0; i< intSeq.length() ; i++) {
    		char cur = intSeq.charAt(i);
    		if ( !intPoints.contains(new Character(cur)) && doesSplit(intSeq, cur) ) {
    			intPoints.add( new Character(cur) );
    		}
    	}
    	return intPoints.size();
	}
	public static ArrayList<Integer> conv( int[] A) {
		ArrayList<Integer> Integers = new ArrayList<Integer>();
		for (int i: A) {
			Integers.add( new Integer(i) );
		}
		return Integers;
	}
	public static Integer I (int i) {
		return new Integer(i);
	}
	public String convert(ArrayList<Integer> intSeq) {
		String s = "";
		for (Integer I: intSeq) {
			int i = I.intValue();
			int j;
			if ( i < 0 || i > 25) {
				j = 3;
			}
			s += "" + getLetter(i);
		}
		return s;
	}
	public ArrayList<String> allIntSequences(int length) {
		if (length == 0) {
			ArrayList<String> baseCase = new ArrayList<String>();
			baseCase.add("");
			return baseCase;
		}
		if (length == 1) {
			ArrayList<String> baseCase = new ArrayList<String>();
			baseCase.add("aa");
			return baseCase;
		}
		ArrayList<String> oldFull = new ArrayList<String>(); // all distinct intersection seq of last length
		ArrayList<String> curFull = new ArrayList<String>(); // all distinct intersection seq of current length
		ArrayList<String> curTrim = new ArrayList<String>(); // all combinatorially distinct seq. of current length
		curFull.add("aa");
		int curLength = 1;
		while ( curLength < length)  {
			oldFull.clear();
			oldFull.addAll(curFull);
			curFull.clear();
			curTrim.clear();
			for (int i=0; i < 2*curLength; i++) {
				curTrim.addAll(levelUp(oldFull, i));
				curFull.addAll(levelUp(oldFull, i));
			}
			curFull.addAll( levelUp(oldFull, 2*curLength) );
			curLength++;
		}
		return curTrim;
	}
	// input a list of intersection sequences with n int points, increase them each to n+1 int points
	//let k be the index to insert the 2nd occurrence of the new int point
	public ArrayList<String> levelUp( ArrayList<String> intSequences, int k) {
		try {
			if ( ! (k < intSequences.get(0).length() +1 ) )  {
				throw new Exception("Cannot insert unless intpoint is before the last digit");
			}
		}
		catch (Exception E) {
			System.err.println(E);
		}
		ArrayList<String> newSequences = new ArrayList<String>();
		for (String intSeq: intSequences) { 
			String shift = shift(intSeq, 1); // shift everything over one digit
			String newSeq = "a" + shift.substring(0, k) + "a" + shift.substring(k);
			newSequences.add(newSeq);
		}
		return newSequences;
	}
	
	public String shift(String S, int i) {
		if ( i < 0 || i > 25) {
    		try { 
    			throw new Exception("Shift error. Note that a == 0, z == 25. Input an integer between these values");
    		}
    		catch (Exception E){
    			System.err.println(E);
    		}
    	}
		String newS = "";
		for (int j=0; j< S.length(); j++) {
			char cur = S.charAt(j);
			int curInt = (int)(cur); // parse the character to its ascii value, then subtract 97
			newS += (char)(curInt+1); // shift over one 
		}
		return newS; 
	}
	
	public char getLetter(int i) { // a ≈ 0, b ≈ 1, ... , z ≈ 25
    	if ( i < 0 || i > 25) {
    		try { 
    			throw new Exception("getLetter error. Note that a == 0, z == 25. Input an integer between these values");
    		}
    		catch (Exception E){
    			System.err.println(E);
    		}
    	}
    	return (char)(i+97);
    }
	
    public int TNS(String intSeq) {  // compute the total nested splits (# splitting trees) of the intSeq
    	ArrayList<Character> intPoints = new ArrayList<Character>();
    	for (int i=0; i< intSeq.length() ; i++) {
    		char cur = intSeq.charAt(i);
    		if ( !intPoints.contains(new Character(cur)) && doesSplit(intSeq, cur) ) {
    			intPoints.add( new Character(cur) );
    		}
    	}
    	if ( intPoints.size() == 0) {  // base case: curve is simple! 
    		return 1;
    	}
    	int total = 0;
    	for ( Character intPoint: intPoints) {
    		char c = intPoint.charValue(); // take the character
    		// add to the sum the product of the total nested splits of the left and right
    		int left = TNS( splitSeq(intSeq, c, false) );
    		int right = TNS(splitSeq(intSeq, c, true) );
    		total += left * right;
    	}
    	return total; 
    }
    
    public boolean doesSplit( String intSeq, char c) {
    	int count = 0;
    	for (int i=0; i < intSeq.length() ; i++) {
    		char s = intSeq.charAt(i);
    		if ( s == c) {
    			count ++;
    		}
    	}
    	return count == 2;
    }
    public String splitSeq(String intSeq, char c, boolean half) {
    	if (!doesSplit(intSeq, c) ) {
    		return null;
    	}
    	int ind1 = -1; int ind2 = -1;
    	for (int i=0; i < intSeq.length() ; i++) {
    		char s = intSeq.charAt(i);
    		if ( s == c) {
    			if ( ind1 == -1 ) { ind1 = i; } 
        		else { ind2 = i; break; }
    		}
    		
    	}
    	String direct = "";
    	String wraparound = "";
    	// direct 
    	for (int i= ind1+1; i < ind2; i++) { // take substring strictly btwn ind1 < j < ind2
    		direct += intSeq.charAt(i);
    	}
    	//wraparound
    	for (int j= ind2 + 1; j < intSeq.length() ; j++) { // take substring strictly btwn ind1 < j < ind2
    		wraparound += intSeq.charAt(j);
    	}
    	for (int j= 0; j < ind1; j++) { // take substring strictly btwn ind1 < j < ind2
    		wraparound += intSeq.charAt(j);
    	}
    	return (half ? wraparound : direct);
    }
    
}


