import javax.swing.*;


import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;

public class Homotopy {
	
	public double area;
	public ArrayList<Integer> anchorIndices;
	
	public Homotopy() {
		this.area = 0;
	}
	
	public Homotopy(double area, ArrayList<Integer> anchors) {
		this.area =  area;
		this.anchorIndices = anchors;
	}
	
	public void setArea(double area) {
		this.area = area; 
		anchorIndices = new ArrayList<Integer>();
	}
	
	public Homotopy add(Homotopy H) { // add their areas and anchors 
		Homotopy newH = new Homotopy();
		newH.area = this.area + H.area;
		newH.anchorIndices = new ArrayList<Integer>();
		newH.anchorIndices.addAll(this.anchorIndices); newH.anchorIndices.addAll(H.anchorIndices);
		return newH;
	}
	
	public String toString() {
		String S = "";
		if (anchorIndices.size() == 0) {
			return "";
		}
		for ( Integer I: anchorIndices) {
			String s = I.toString();
			S += s + "->";
		}
		S = S.substring(0, S.length()-1);
		return S + " w/ area + " + this.area;
	}
	
	public boolean equals(Homotopy H) {
		return this.anchorIndices.equals( H.anchorIndices) && (this.area - H.area) < .02;
	}
	
}
